package earth.krakatao.protocol;

import java.util.function.Consumer;
import lombok.Getter;
import lombok.Setter;

@Getter
public class KraSocketClientProtocolMessage {

  private final byte status;
  private final int cmdID; // long
  private final int dest;
  private final String uuid;
  private final short cmdNumber;
  private final String args;
  private final Consumer<KraSocketClientProtocolMessage> messageConsumer;
  @Setter
  private int trySendCount;
  @Setter
  private long time;

  public KraSocketClientProtocolMessage(byte status, int cmdID, int dest, String uuid,
      int cmdNumber, String args, Consumer<KraSocketClientProtocolMessage> messageConsumer) {
    this.status = status;
    this.cmdID = cmdID;
    this.dest = dest;
    this.uuid = uuid;
    this.cmdNumber = (short) cmdNumber;
    this.args = args;
    this.messageConsumer = messageConsumer;

    this.trySendCount = 0;
    this.time = System.currentTimeMillis();
  }

  public int getStatus() {
    return Byte.toUnsignedInt(status);
  }

  public int getCmdNumber() {
    return Short.toUnsignedInt(cmdNumber);
  }
}
